
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.image.*;

import java.applet.*;
import java.util.HashMap;
/**
 * Write a description of class SplashScreen here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class BPanel extends JPanel implements MouseListener,ActionListener,KeyListener
{
    BorlandBase mainFrame;
    boolean animateAfter;
    Color backgroundColor=Color.white;
    HashMap<String,AudioClip> allSounds = new HashMap<String,AudioClip>();
    BTextField textField = new BTextField();
    Image image;
    public void init() 
    { 

        addMouseListener(this);
        addKeyListener(this);
        //setPreferredSize( Toolkit.getDefaultToolkit().getScreenSize());
        // jframe.getContentPane().setBackground(Color.red);        
        setLayout (new FlowLayout() );

        setVisible(true);    
        //setOpaque(true)
        initialize();

    } //in paint I tell it to paint the components and then draw a line

    public void setBackgroundImage(String fileName)
    {
        try
        {
            image=javax.imageio.ImageIO.read(new java.io.File(fileName));

        }

        catch (Exception e){}
    }

    public void setMainFrame(BorlandBase main)
    {
        main.stop();
        mainFrame=main;
        main.noDrawing=true;
    }

    public void setAnimation(boolean b)
    {
        animateAfter=true;
    }

    public void initialize(){

    }

    public void setBackgroundColor(Color c)
    {
        setBackground(c);
        backgroundColor=c;
    }

    public void addItem(Component c)
    {
        add(c);
        if (c instanceof JButton)
            ((JButton) c).addActionListener(this);  

    }    

    public void drawImage(Graphics g, String filename,int x,int y)
    {
        try
        {           
            Image img = javax.imageio.ImageIO.read(this.getClass().getResource(filename));
            g.drawImage(img,x,y,null);

        }
        catch (Exception e){System.out.println("error finding image file");}
    }

    public void drawImage(Graphics g, String filename,int x,int y,double scale)
    {
        try
        {

            Image img = javax.imageio.ImageIO.read(this.getClass().getResource(filename));
            int w = img.getWidth(null);
            int h = img.getHeight(null);
            g.drawImage(img,x,y,(int)(w*scale),(int)(h*scale),null);

        }
        catch (Exception e){System.out.println("error finding image file");}
    }

    public void playSound(String filename)
    {
        if (allSounds.containsKey(filename))
            allSounds.get(filename).play();
        else
        {
            try
            {
                AudioClip  clip = Applet.newAudioClip(this.getClass().getResource(filename));
                allSounds.put(filename,clip);
                clip.play();
            }
            catch (Exception e){
                System.out.println("trouble with loading sound");
            }
        }

    }

    public void paintComponent(Graphics g) {
        super.paintComponent(g);  
        if (image != null)
        {
            g.drawImage(image,0,0,this);
        }

        paintScreen(g);
    }

    public void paintScreen(Graphics g){
    }
    //when someone presses the mouse button
    public void mousePressed(MouseEvent e)
    {     

    }

    //when someone releases the mouse button
    public void mouseReleased(MouseEvent e)
    {     

    }

    // when the mouse enters the applet
    public void mouseEntered(MouseEvent e)
    {     

    }

    //when the mouse leaves the applet
    public void mouseExited(MouseEvent e)
    {     

    }

    //when the mouse button is clicked
    public void mouseClicked(MouseEvent e)
    {
        requestFocus(); //this bring the focus make to the main progra

    }

    //This is the method that will be called if a key is pressed
    //It is neccessary if you are using getKeyCode()
    public void keyPressed(KeyEvent e)
    {
        /*
        char theChar=e.getKeyChar();
        int theCode=e.getKeyCode();    */   
    }

    //This is the method that will be called if a key is released
    //It is unneccessary to use this method, but you must include it
    public void keyReleased(KeyEvent e)
    {  
    }

    //This is the method that will be called if a key is typed, however you cant use getKeyCode, so
    // you are better to use keyPressed
    public void keyTyped(KeyEvent e)
    {    
    }

    //now we have to have a method actionPerformed that will be called if an action happens
    //we then see which component had the action on it
    public void actionPerformed(ActionEvent thisEvent)
    {
        Object source = thisEvent.getSource();
        buttonPressed((Component)source);
    }

    public void buttonPressed(Component source){}

    public void closePanel()
    {
        setVisible(false);
        mainFrame.remove(mainFrame.openPanel);
        mainFrame.restoreContentPane();
        mainFrame.revalidate();
        mainFrame.repaint();
        mainFrame.noDrawing=false;
        if (animateAfter==true)
        {
            mainFrame.setAnimation(true);
            mainFrame.start();
        }
    }

    public void echo(String s)
    {
        System.out.println(s);
    }

    public void echo(int s)
    {
        System.out.println(s);
    }

    public void echo(double s)
    {
        System.out.println(s);
    }

    public int findRandom (int start, int end)
    {
        int multiplier = end-start+1;
        int random = (int) (Math.random()*multiplier)+start;
        return random;
    }

    public Color findRandomColor ()
    {
        int red= (int)(256 * Math.random());
        int green= (int)(256 * Math.random());
        int blue= (int)(256 * Math.random());
        Color randomColor=new Color(red,green,blue);
        return randomColor;
    } 

}